ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.17 by root, Sun Dec 12 00:38:36 2010 UTC vs.
Revision 1.49 by root, Sun Jul 10 01:37:56 2011 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in (or to replace in your .staticperlrc)
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9DLCACHE=
9 10
10# perl build variables 11# perl build variables
12MAKE=make
11PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 13PERL_VERSION=5.12.4 # 5.8.9 is also a good choice
14PERL_CC=cc
12PERL_CONFIGURE="" # additional Configure arguments 15PERL_CONFIGURE="" # additional Configure arguments
13PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 16PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
14PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
15 18
16ARCH="$(uname -m)" 19ARCH="$(uname -m)"
17 20
18case "$ARCH" in 21case "$ARCH" in
27esac 30esac
28 31
29# -Wl,--gc-sections makes it impossible to check for undefined references 32# -Wl,--gc-sections makes it impossible to check for undefined references
30# for some reason so we need to patch away the "-no" after Configure and before make :/ 33# for some reason so we need to patch away the "-no" after Configure and before make :/
31# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 34# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
32PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 35#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LDFLAGS=
33PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 37PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
34 38
35# some configuration options for modules 39# some configuration options for modules
36export PERL_MM_USE_DEFAULT=1 40PERL_MM_USE_DEFAULT=1
41PERL_MM_OPT="MAN1PODS= MAN3PODS="
37#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 42#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
38export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 43#EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
44export PERL_MM_USE_DEFAULT PERL_MM_OPT
39 45
40# which extra modules to install by default from CPAN that are 46# which extra modules to install by default from CPAN that are
41# required by mkbundle 47# required by mkbundle
42STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 48STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
43 49
44# which extra modules you might want to install 50# which extra modules you might want to install
45EXTRA_MODULES="" 51EXTRA_MODULES=""
46 52
47# overridable functions 53# overridable functions
48preconfigure() { : ; } 54preconfigure() { : ; }
55patchconfig() { : ; }
49postconfigure() { : ; } 56postconfigure() { : ; }
50postbuild() { : ; } 57postbuild() { : ; }
51postinstall() { : ; } 58postinstall() { : ; }
52 59
53# now source user config, if any 60# now source user config, if any
60fi 67fi
61 68
62############################################################################# 69#############################################################################
63# support 70# support
64 71
65MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
66PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 72PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
67 73
68unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 74unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
75unset PERL_MB_OPT
69export LC_ALL=C # just to be on the safe side 76LC_ALL=C; export LC_ALL # just to be on the safe side
77
78# prepend PATH - not required by staticperl itself, but might make
79# life easier when working in e.g. "staticperl cpan / look"
80PATH="$PERL_PREFIX/perl/bin:$PATH"
70 81
71# set version in a way that Makefile.PL can extract 82# set version in a way that Makefile.PL can extract
72VERSION=VERSION; eval \ 83VERSION=VERSION; eval \
73$VERSION=0.911 84$VERSION="1.31"
74 85
75BZ2=bz2 86BZ2=bz2
76BZIP2=bzip2 87BZIP2=bzip2
77 88
78fatal() { 89fatal() {
121 132
122############################################################################# 133#############################################################################
123# download/configure/compile/install perl 134# download/configure/compile/install perl
124 135
125clean() { 136clean() {
126 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 137 rm -rf "$STATICPERL/src"
138}
139
140realclean() {
141 rm -f "$PERL_PREFIX/staticstamp.postinstall"
142 rm -f "$PERL_PREFIX/staticstamp.install"
143 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
127} 144}
128 145
129fetch() { 146fetch() {
130 rcd "$STATICPERL" 147 rcd "$STATICPERL"
131 148
132 mkdir -p src 149 mkdir -p src
133 rcd src 150 rcd src
134 151
135 if ! [ -d "perl-$PERL_VERSION" ]; then 152 if ! [ -d "perl-$PERL_VERSION" ]; then
136 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then 153 PERLTAR=perl-$PERL_VERSION.tar.$BZ2
137 154
155 if ! [ -e $PERLTAR ]; then
138 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2" 156 URL="$CPAN/src/5.0/$PERLTAR"
139 157
140 verblock <<EOF 158 verblock <<EOF
141downloading perl 159downloading perl
142to manually download perl yourself, place 160to manually download perl yourself, place
143perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 161perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
144trying $URL 162trying $URL
145EOF
146 163
164either curl or wget is required for automatic download.
165curl is tried first, then wget.
166
167you can configure a download cache directory via DLCACHE
168in your .staticperlrc to avoid repeated downloads.
169EOF
170
147 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 171 rm -f $PERLTAR~ # just to be on the safe side
148 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 172 { [ "$DLCACHE" ] && cp "$DLCACHE"/$PERLTAR $PERLTAR~ >/dev/null 2>&1; } \
149 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 173 || wget -O $PERLTAR~ "$URL" \
174 || curl -f >$PERLTAR~ "$URL" \
150 || fatal "$URL: unable to download" 175 || fatal "$URL: unable to download"
151 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 176 rm -f $PERLTAR
177 mv $PERLTAR~ $PERLTAR
178 if [ "$DLCACHE" ]; then
179 mkdir -p "$DLCACHE"
180 cp $PERLTAR "$DLCACHE"/$PERLTAR~ && \
181 mv "$DLCACHE"/$PERLTAR~ "$DLCACHE"/$PERLTAR
182 fi
152 fi 183 fi
153 184
154 verblock <<EOF 185 verblock <<EOF
155unpacking perl 186unpacking perl
156EOF 187EOF
157 188
158 mkdir -p unpack 189 mkdir -p unpack
159 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 190 rm -rf unpack/perl-$PERL_VERSION
191 $BZIP2 -d <$PERLTAR | ( cd unpack && tar xf - ) \
160 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 192 || fatal "$PERLTAR: error during unpacking"
161 chmod -R u+w unpack/perl-$PERL_VERSION 193 chmod -R u+w unpack/perl-$PERL_VERSION
162 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 194 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
163 rmdir -p unpack 195 rmdir -p unpack
164 fi 196 fi
165} 197}
166 198
167# similar to GNU-sed -i or perl -pi 199# similar to GNU-sed -i or perl -pi
168sedreplace() { 200sedreplace() {
169 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 201 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
202 rm -f "$2"
170 mv "$2~" "$2" 203 mv "$2~" "$2"
204}
205
206configure_failure() {
207 cat <<EOF
208
209
210***
211*** Configure failed - see above for the exact error message(s).
212***
213*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
214*** flags are not supported by your compiler. Less often, this is because
215*** PERL_LIBS either contains a library not available on your system (such as
216*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
217***
218*** You can provide your own flags by creating a ~/.staticperlrc file with
219*** variable assignments. For example (these are the actual values used):
220***
221
222PERL_CC="$PERL_CC"
223PERL_CCFLAGS="$PERL_CCFLAGS"
224PERL_OPTIMIZE="$PERL_OPTIMIZE"
225PERL_LDFLAGS="$PERL_LDFLAGS"
226PERL_LIBS="$PERL_LIBS"
227
228EOF
229 exit 1
171} 230}
172 231
173configure() { 232configure() {
174 fetch 233 fetch
175 234
181configuring $STATICPERL/src/perl-$PERL_VERSION 240configuring $STATICPERL/src/perl-$PERL_VERSION
182EOF 241EOF
183 242
184 rm -f "$PERL_PREFIX/staticstamp.install" 243 rm -f "$PERL_PREFIX/staticstamp.install"
185 244
186 make distclean >/dev/null 2>&1 245 "$MAKE" distclean >/dev/null 2>&1
187 246
247 sedreplace '/^#define SITELIB/d' config_h.SH
248
188 # I hate them 249 # I hate them for this
189 grep -q -- -fstack-protector Configure && \ 250 grep -q -- -fstack-protector Configure && \
190 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 251 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
191 252
192 preconfigure 253 # what did that bloke think
254 grep -q -- usedl=.define hints/darwin.sh && \
255 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
256
257 preconfigure || fatal "preconfigure hook failed"
193 258
194# trace configure \ 259# trace configure \
195 sh Configure -Duselargefiles \ 260 sh Configure -Duselargefiles \
196 -Uuse64bitint \ 261 -Uuse64bitint \
197 -Dusemymalloc=n \ 262 -Dusemymalloc=n \
198 -Uusedl \ 263 -Uusedl \
199 -Uusethreads \ 264 -Uusethreads \
200 -Uuseithreads \ 265 -Uuseithreads \
201 -Uusemultiplicity \ 266 -Uusemultiplicity \
202 -Duseperlio \
203 -Uusesfio \ 267 -Uusesfio \
204 -Uuseshrplib \ 268 -Uuseshrplib \
269 -Uinstallusrbinperl \
205 -Dcppflags="$PERL_CPPFLAGS" \ 270 -A ccflags=" $PERL_CCFLAGS" \
206 -Dccflags="-g2 -fno-strict-aliasing" \ 271 -Dcc="$PERL_CC" \
207 -Doptimize="$PERL_OPTIMIZE" \ 272 -Doptimize="$PERL_OPTIMIZE" \
208 -Dldflags="$PERL_LDFLAGS" \ 273 -Dldflags="$PERL_LDFLAGS" \
209 -Dlibs="$PERL_LIBS" \ 274 -Dlibs="$PERL_LIBS" \
210 -Dprefix="$PERL_PREFIX" \ 275 -Dprefix="$PERL_PREFIX" \
211 -Dbin="$PERL_PREFIX/bin" \ 276 -Dbin="$PERL_PREFIX/bin" \
212 -Dprivlib="$PERL_PREFIX/lib" \ 277 -Dprivlib="$PERL_PREFIX/lib" \
213 -Darchlib="$PERL_PREFIX/lib" \ 278 -Darchlib="$PERL_PREFIX/lib" \
214 -Uusevendorprefix \ 279 -Uusevendorprefix \
215 -Dsitelib="$PERL_PREFIX/lib" \ 280 -Dsitelib="$PERL_PREFIX/lib" \
216 -Dsitearch="$PERL_PREFIX/lib" \ 281 -Dsitearch="$PERL_PREFIX/lib" \
217 -Usitelibexp \
218 -Uman1dir \ 282 -Uman1dir \
219 -Uman3dir \ 283 -Uman3dir \
220 -Usiteman1dir \ 284 -Usiteman1dir \
221 -Usiteman3dir \ 285 -Usiteman3dir \
222 -Dpager=/usr/bin/less \ 286 -Dpager=/usr/bin/less \
223 -Demail="$EMAIL" \ 287 -Demail="$EMAIL" \
224 -Dcf_email="$EMAIL" \ 288 -Dcf_email="$EMAIL" \
225 -Dcf_by="$EMAIL" \ 289 -Dcf_by="$EMAIL" \
226 $PERL_CONFIGURE \ 290 $PERL_CONFIGURE \
291 -Duseperlio \
227 -dE || fatal "Configure failed" 292 -dE || configure_failure
228 293
229 sedreplace ' 294 sedreplace '
230 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 295 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
231 s/ *-fno-stack-protector */ /g 296 s/ *-fno-stack-protector */ /g
232 ' config.sh 297 ' config.sh
233 298
299 patchconfig || fatal "patchconfig hook failed"
300
234 sh Configure -S || fatal "Configure -S failed" 301 sh Configure -S || fatal "Configure -S failed"
235 302
236 postconfigure || fatal "postconfigure hook failed" 303 postconfigure || fatal "postconfigure hook failed"
237 304
238 touch staticstamp.configure 305 : > staticstamp.configure
306}
307
308write_shellscript() {
309 {
310 echo "#!/bin/sh"
311 echo "STATICPERL=\"$STATICPERL\""
312 echo "PERL_PREFIX=\"$PERL_PREFIX\""
313 echo "MAKE=\"$MAKE\""
314 cat
315 } >"$PERL_PREFIX/bin/$1"
316 chmod 755 "$PERL_PREFIX/bin/$1"
239} 317}
240 318
241build() { 319build() {
242 configure 320 configure
243 321
247building $STATICPERL/src/perl-$PERL_VERSION 325building $STATICPERL/src/perl-$PERL_VERSION
248EOF 326EOF
249 327
250 rm -f "$PERL_PREFIX/staticstamp.install" 328 rm -f "$PERL_PREFIX/staticstamp.install"
251 329
252 make || fatal "make: error while building perl" 330 "$MAKE" || fatal "make: error while building perl"
253 331
254 postbuild || fatal "postbuild hook failed" 332 postbuild || fatal "postbuild hook failed"
333}
334
335_postinstall() {
336 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
337 NOCHECK_INSTALL=+
338 instcpan $STATICPERL_MODULES
339 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
340
341 postinstall || fatal "postinstall hook failed"
342
343 : > "$PERL_PREFIX/staticstamp.postinstall"
344 fi
255} 345}
256 346
257install() { 347install() {
258 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then 348 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
259 build 349 build
264EOF 354EOF
265 355
266 ln -sf "perl/bin/" "$STATICPERL/bin" 356 ln -sf "perl/bin/" "$STATICPERL/bin"
267 ln -sf "perl/lib/" "$STATICPERL/lib" 357 ln -sf "perl/lib/" "$STATICPERL/lib"
268 358
359 mkdir "$STATICPERL/patched"
360
269 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 361 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
270 rm -rf "$PERL_PREFIX" # by this rm -rf 362 rm -rf "$PERL_PREFIX" # by this rm -rf
271 363
272 make install || fatal "make install: error while installing" 364 "$MAKE" install || fatal "make install: error while installing"
273 365
274 rcd "$PERL_PREFIX" 366 rcd "$PERL_PREFIX"
275 367
276 # create a "make install" replacement for CPAN 368 # create a "make install" replacement for CPAN
277 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 369 write_shellscript SP-make-install-make <<'EOF'
278make || exit 370#CAT make-install-make.sh
279
280if find blib/arch/auto -type f | grep -q -v .exists; then
281 echo Probably an XS module, rebuilding perl
282 if make perl; then
283 mv perl "$PERL_PREFIX"/bin/perl
284 make -f Makefile.aperl map_clean
285 else
286 make -f Makefile.aperl map_clean
287 exit 1
288 fi
289fi
290
291make install UNINST=1
292EOF 371EOF
293 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
294 372
373 # create a "patch modules" helper
374 write_shellscript SP-patch-postinstall <<'EOF'
375#CAT patch-postinstall.sh
376EOF
377
378 "$PERL_PREFIX/bin/SP-patch-postinstall"
379
295 # trick CPAN into avoiding ~/.cpan completely 380 # help to trick CPAN into avoiding ~/.cpan completely
296 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 381 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
297 382
383 # we call cpan with -MCPAN::MyConfig in this script, which
384 # is strictly unnecssary as we have to patch CPAN anyway,
385 # so consider it "for good measure".
298 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 386 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
299 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 387 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
300 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 388 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
301 CPAN::Shell->o (conf => q<init>); 389 CPAN::Shell->o (conf => q<init>);
302 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 390 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
303 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 391 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
304 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 392 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
305 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 393 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
306 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 394 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
307 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 395 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
308 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 396 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
309 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 397 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
398 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
310 CPAN::Shell->o (conf => q<commit>); 399 CPAN::Shell->o (conf => q<commit>);
311 ' || fatal "error while initialising CPAN" 400 ' || fatal "error while initialising CPAN"
312 401
313 touch "$PERL_PREFIX/staticstamp.install" 402 : > "$PERL_PREFIX/staticstamp.install"
314 fi 403 fi
315 404
405 _postinstall
406}
407
408import() {
409 IMPORT="$1"
410
411 rcd "$STATICPERL"
412
316 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then 413 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
317 NOCHECK_INSTALL=+ 414 verblock <<EOF
318 instcpan $STATICPERL_MODULES 415import perl from $IMPORT to $STATICPERL
319 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 416EOF
320 417
321 postinstall || fatal "postinstall hook failed" 418 rm -rf bin cpan lib patched perl src
419 mkdir -m 755 perl perl/bin
420 ln -s perl/bin/ bin
421 ln -s "$IMPORT" perl/bin/
322 422
323 touch "$PERL_PREFIX/staticstamp.postinstall" 423 : > "$PERL_PREFIX/staticstamp.install"
324 fi 424 fi
425
426 _postinstall
325} 427}
326 428
327############################################################################# 429#############################################################################
328# install a module from CPAN 430# install a module from CPAN
329 431
333 verblock <<EOF 435 verblock <<EOF
334installing modules from CPAN 436installing modules from CPAN
335$@ 437$@
336EOF 438EOF
337 439
338 for mod in "$@"; do 440 #"$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install $_ for @ARGV' -- "$@" | tee "$STATICPERL/instcpan.log"
339 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 441 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install $_ for @ARGV' -- "$@" | tee "$STATICPERL/instcpan.log"
340 || fatal "$mod: unable to install from CPAN" 442
341 done 443 if grep -q " -- NOT OK\$" "$STATICPERL/instcpan.log"; then
444 fatal "failure while installing modules from CPAN ($@)"
445 fi
342 rm -rf "$STATICPERL/build" 446 rm -f "$STATICPERL/instcpan.log"
343} 447}
344 448
345############################################################################# 449#############################################################################
346# install a module from unpacked sources 450# install a module from unpacked sources
347 451
356 for mod in "$@"; do 460 for mod in "$@"; do
357 echo 461 echo
358 echo $mod 462 echo $mod
359 ( 463 (
360 rcd $mod 464 rcd $mod
361 make -f Makefile.aperl map_clean >/dev/null 2>&1 465 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
362 make distclean >/dev/null 2>&1 466 "$MAKE" distclean >/dev/null 2>&1
363 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 467 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
364 make || fatal "$mod: error building module" 468 "$MAKE" || fatal "$mod: error building module"
365 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 469 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
366 make distclean >/dev/null 2>&1 470 "$MAKE" distclean >/dev/null 2>&1
367 exit 0 471 exit 0
368 ) || exit $? 472 ) || exit $?
369 done 473 done
370} 474}
371 475
402#CAT mkbundle 506#CAT mkbundle
403MKBUNDLE 507MKBUNDLE
404} 508}
405 509
406bundle() { 510bundle() {
511 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
407 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 512 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
408 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 513 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
409 CACHE="$STATICPERL/cache" 514 CACHE="$STATICPERL/cache"
410 mkdir -p "$CACHE" 515 mkdir -p "$CACHE"
411 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 516 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
419 command="${1#--}"; shift 524 command="${1#--}"; shift
420 case "$command" in 525 case "$command" in
421 version ) 526 version )
422 echo "staticperl version $VERSION" 527 echo "staticperl version $VERSION"
423 ;; 528 ;;
424 fetch | configure | build | install | clean | distclean) 529 fetch | configure | build | install | clean | realclean | distclean )
425 ( "$command" ) 530 ( "$command" ) || exit
531 ;;
532 import )
533 ( import "$1" ) || exit
534 shift
426 ;; 535 ;;
427 instsrc ) 536 instsrc )
428 ( instsrc "$@" ) 537 ( instsrc "$@" ) || exit
429 exit 538 exit
430 ;; 539 ;;
431 instcpan ) 540 instcpan )
432 ( instcpan "$@" ) 541 ( instcpan "$@" ) || exit
542 exit
543 ;;
544 perl )
545 ( install ) || exit
546 exec "$PERL_PREFIX/bin/perl" "$@"
433 exit 547 exit
434 ;; 548 ;;
435 cpan ) 549 cpan )
436 ( install ) 550 ( install ) || exit
551 PERL="$PERL_PREFIX/bin/perl"
552 export PERL
437 "$PERL_PREFIX/bin/cpan" "$@" 553 exec "$PERL_PREFIX/bin/cpan" "$@"
438 exit 554 exit
439 ;; 555 ;;
440 mkbundle ) 556 mkbundle )
441 ( install ) 557 ( install ) || exit
442 bundle "$@" 558 bundle "$@"
443 exit 559 exit
444 ;; 560 ;;
445 mkperl ) 561 mkperl )
446 ( install ) 562 ( install ) || exit
447 bundle --perl "$@" 563 bundle --perl "$@"
448 exit 564 exit
449 ;; 565 ;;
450 mkapp ) 566 mkapp )
451 ( install ) 567 ( install ) || exit
452 bundle --app "$@" 568 bundle --app "$@"
453 exit 569 exit
454 ;; 570 ;;
455 help ) 571 help )
456 podusage 2 572 podusage 2

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines